package com.jcg.jpa.mappedBy;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class AppDemo {

	private static final EntityManagerFactory emFactoryObj;
	private static final String PERSISTENCE_UNIT_NAME = "JPAMappedbyExample";	

	static {
		emFactoryObj = Persistence.createEntityManagerFactory(PERSISTENCE_UNIT_NAME);
	}

	// This Method Is Used To Retrieve The 'EntityManager' Object
	public static EntityManager getEntityManager() {
		return emFactoryObj.createEntityManager();
	}

	private static void insertRecord() {
		EntityManager entityMgrObj = getEntityManager();
		if (null != entityMgrObj) {
			entityMgrObj.getTransaction().begin();

			Employee empObj = new Employee();
			empObj.setName("Harry Potter");

			Passport passportDetailsObj = new Passport();
			passportDetailsObj.setAddressLine1("Cupboard Under D' Stairs");
			passportDetailsObj.setAddressLine2(" 4 Privet Drive");
			passportDetailsObj.setState("Little Whinging");
			passportDetailsObj.setCountry("Surrey");
			empObj.setPassportDetails(passportDetailsObj);
			entityMgrObj.persist(empObj);

			entityMgrObj.getTransaction().commit();

			entityMgrObj.clear();
			System.out.println("Record Successfully Inserted In The Database");
		}
	}

	public static void main(String[] args) {
		insertRecord();
	}
}